/*
 *
 *  Copyright (C) 2007-2020 SimplyCore, LLC
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *
 */

#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/slab.h>
#include <linux/ioctl.h>
#include <linux/usb.h>
#include <linux/types.h>
#include <linux/fs.h>
#include <linux/cdev.h>
#include <linux/poll.h>
#include <linux/spinlock.h>
#include <linux/list.h>
#include <linux/version.h>
#include <linux/kref.h>
#include <linux/device.h>
#include <linux/compat.h>
#include <linux/mm.h>
#include <linux/vmalloc.h>
#include <linux/module.h>
#include <asm/uaccess.h>
#define KERNEL_GT(IlIlIll,lIlIIlI,IlIIlIIl)			(LINUX_VERSION_CODE > \
KERNEL_VERSION((IlIlIll),(lIlIIlI),(IlIIlIIl)))
#define KERNEL_LT(IlIlIll,lIlIIlI,IlIIlIIl)			(LINUX_VERSION_CODE < \
KERNEL_VERSION((IlIlIll),(lIlIIlI),(IlIIlIIl)))
#define KERNEL_EQ(IlIlIll,lIlIIlI,IlIIlIIl)			(LINUX_VERSION_CODE == \
KERNEL_VERSION((IlIlIll),(lIlIIlI),(IlIIlIIl)))
#define KERNEL_GT_EQ(IlIlIll,lIlIIlI,IlIIlIIl)			(LINUX_VERSION_CODE >= \
KERNEL_VERSION((IlIlIll),(lIlIIlI),(IlIIlIIl)))
#define KERNEL_LT_EQ(IlIlIll,lIlIIlI,IlIIlIIl)			(LINUX_VERSION_CODE <= \
KERNEL_VERSION((IlIlIll),(lIlIIlI),(IlIIlIIl)))
#if defined(RHEL_RELEASE_CODE) 
#define RHEL_RELEASE_GT(IlIlIll,lIlIIlI) 		(RHEL_RELEASE_CODE > \
RHEL_RELEASE_VERSION((IlIlIll),(lIlIIlI)))
#define RHEL_RELEASE_LT(IlIlIll,lIlIIlI)		(RHEL_RELEASE_CODE < \
RHEL_RELEASE_VERSION((IlIlIll),(lIlIIlI)))
#define RHEL_RELEASE_EQ(IlIlIll,lIlIIlI)		(RHEL_RELEASE_CODE == \
RHEL_RELEASE_VERSION((IlIlIll),(lIlIIlI)))
#define RHEL_RELEASE_GT_EQ(IlIlIll,lIlIIlI)		(RHEL_RELEASE_CODE >= \
RHEL_RELEASE_VERSION((IlIlIll),(lIlIIlI)))
#define RHEL_RELEASE_LT_EQ(IlIlIll,lIlIIlI)		(RHEL_RELEASE_CODE <= \
RHEL_RELEASE_VERSION((IlIlIll),(lIlIIlI)))
#else
#define RHEL_RELEASE_GT(IlIlIll,lIlIIlI) 		(0x1d61+1361-0x22b2)
#define RHEL_RELEASE_LT(IlIlIll,lIlIIlI)		(0x12d1+1876-0x1a25)
#define RHEL_RELEASE_EQ(IlIlIll,lIlIIlI)		(0xb11+426-0xcbb)
#define RHEL_RELEASE_GT_EQ(IlIlIll,lIlIIlI)		(0xe93+1135-0x1302)
#define RHEL_RELEASE_LT_EQ(IlIlIll,lIlIIlI)		(0x1afb+1751-0x21d2)
#endif

#ifndef BUS_ID_SIZE
#define BUS_ID_SIZE (0x86a+1312-0xd76)
#endif
#include "../public/pubstt2.h"
#include "../public/apitypes.h"
#include "../public/pubuniprotocol.h"
#include "../public/interface.h"
#include "../public/public_devices.h"
#include "utils.h"
#include "driver.h"
#include "cdev.h"
#include "stub.h"
#include "vhci.h"
#include "minor_loader.h"
#include "minor_stub.h"
#include "minor_vbus.h"
#include "minor_vstub.h"
#include "urb_chain.h"
#include "sg.h"

#if KERNEL_LT_EQ((0x466+1417-0x9ed),(0x4a+9254-0x246a),(0x1155+1307-0x1661))
#define llIlllIII __stringify(KBUILD_MODNAME)
#else
#define llIlllIII KBUILD_MODNAME
#endif

#ifndef CONFIG_PRINTK_TIME
#define IIIlIlll(lIIllll, IIIIlIl...) printk(KERN_DEBUG \
"\x5b\x25\x30\x39\x75\x5d\x20\x25\x73\x3a\x20" lIIllll, jiffies_to_msecs(jiffies\
), llIlllIII, ## IIIIlIl)
#else
#define IIIlIlll(lIIllll, IIIIlIl...) printk(KERN_DEBUG "\x25\x73\x3a\x20" \
lIIllll, llIlllIII, ## IIIIlIl)
#endif

#define llIIlIIII(IIlIllIl,IIllllIII,IIlIIlII) do { \
	char IlllIlIl[(0x5cf+7220-0x219f)]; \
	char *lIIllIIl; \
	size_t i; \
	for(i=(0xac+3486-0xe4a),lIIllIIl=IlllIlIl;i<(IIlIIlII);i++) \
	{ \
		if((i%(0xca+7608-0x1e7a)) == (0x1889+1582-0x1eb7) && i > (0x13c6+3380-0x20fa))\
 \
		{ \
			Illll(IIlIllIl "\x25\x73" "\n", IlllIlIl); \
			lIIllIIl=IlllIlIl; \
		} \
		sprintf(lIIllIIl,"\x25\x30\x32\x58\x20", (IIllllIII)[i]); \
		lIIllIIl+=(0x1240+180-0x12f1); \
	} \
	if(lIIllIIl!=IlllIlIl) IIIlIlll(IIlIllIl "\x25\x73" "\n", IlllIlIl); \
} while ((0x4a3+7119-0x2072))

#define IlIIIlIII(IIlIllIl,IIllllIII,IIlIIlII) do { \
	char IlllIlIl[(0x18d+7295-0x1da8)]; \
	char *lIIllIIl; \
	size_t i; \
	for(i=(0x1764+55-0x179b),lIIllIIl=IlllIlIl;(i<(IIlIIlII))&&(i<\
(0x1833+718-0x1ae1));i++,lIIllIIl+=(0xdca+5473-0x2328)) \
	{ \
		sprintf(lIIllIIl,"\x25\x30\x32\x58\x20", ((unsigned char*)(IIllllIII))[i]); \
	} \
	if(i>(0x14af+1754-0x1b89)) {IIIlIlll(IIlIllIl "\x20\x25\x73\x25\x73" "\n", \
IlllIlIl, (i<(IIlIIlII)) ? "\x2e\x2e\x2e" : "");} \
} while ((0xb9c+5546-0x2146))

#ifdef _USBD_DEBUG_
#define Illll(lIIllll, IIIIlIl...) IIIlIlll(lIIllll, ##IIIIlIl)
#define IIlll(lIIllll, IIIIlIl...) IIIlIlll("\x25\x73\x3a\x20" lIIllll, __func__\
, ##IIIIlIl)
#define lllIIllII(IllIIlIl,lIllllII,IIlIllll) llIIlIIII(IllIIlIl,lIllllII,\
IIlIllll)
#define IIlIlIlll(IllIIlIl,lIllllII,IIlIllll) IlIIIlIII(IllIIlIl,lIllllII,\
IIlIllll)
#else
#define Illll(lIIllll, IIIIlIl...) do {} while((0x358+4133-0x137d))
#define IIlll(lIIllll, IIIIlIl...) do {} while((0x1f4a+1667-0x25cd))
#define lllIIllII(IllIIlIl,lIllllII,IIlIllll) do {} while((0x1b51+2822-0x2657))
#define IIlIlIlll(IllIIlIl,lIllllII,IIlIllll) do {} while((0x16ca+3341-0x23d7))
#endif

#define llIlII(lIIllll, IIIIlIl...) IIIlIlll(lIIllll, ##IIIIlIl)
#define IIllIIlIlI(IllIIlIl,lIllllII,IIlIllll) llIIlIIII(IllIIlIl,lIllllII,\
IIlIllll)
#define lllIlIlIl(IllIIlIl,lIllllII,IIlIllll) IlIIIlIII(IllIIlIl,lIllllII,\
IIlIllll)
extern size_t lIIIIll;
#if KERNEL_LT_EQ((0x1245+1214-0x1701),(0x15c5+3558-0x23a5),(0x1465+4238-0x24dc))
typedef unsigned long uintptr_t;
#endif
#if KERNEL_LT_EQ((0x929+4368-0x1a37),(0xc73+6293-0x2502),(0x366+1408-0x8d7))
#define atomic_xchg(lIIlllIIIl, new) (xchg(&((lIIlllIIIl)->counter), new))
#endif
#if KERNEL_LT((0xcb0+6300-0x2549),(0x54d+4209-0x15ac),(0x1021+5702-0x2667))




#undef strncasecmp
#define strncasecmp strnicmp
#endif

